#!/usr/bin/env node
const prompt = require('prompts');
const validator=require('@hakeem_shamavu/email-validator')
const io = require('socket.io-client');


const client = io.connect('https://myserver.hakrichteam.com/clientSide');

const answe =[
    {
        type:'text',
        name: 'Asw',
        message: 'Do you have an account: ',
        validator: /^[YynN]$/,
        validate: Asw=>validator.matching(Asw, /^[YynN]$/, 1)? true :'Sorry just (y|n) or (Y|N) allowed!',
        warning: 'Sorry just (y|n) or (Y|N) allowed!'
    }
] 

// n or N = new message.
// c or C = connect to another email.
// i or I = check connection.
// o or O = disconnect.
// h or H = help.

const pr =[
    {
        type:'text',
        name: 'option',
        message: 'Option: ',
        validate: option=>validator.matching(option, /^[NncCOoiIhH]$/, 1)? true :'Wrong option type H for help',
        warning: 'Wrong option type H for help'
    }
] 
const passw = [
{
    type:'text',
    name: 'email',
    message: 'Your Email: ',
    validate: email=>validator.validate(email)? true :'Email invalid!'
}
,{
    type:'text',
    name: 'psw',
    message: 'Your Password: ',
    hidden: true
}

]
const contTo = [{
    type:'text',
    name: 'cts',
    message: 'Connect with: ',
    validate: cts=>validator.validate(cts)? true :'Email invalid!',
    warning: 'Invalid Email address!'
}]
const user = [
    {
        type:'text',
        name: 'usr',
        message: 'Username: ',
        validate: usr=>validator.matching(usr, /^[a-zA-Z\s\-]+$/)? true :'Username must be only letters, spaces, or dashes!',
        
    },
    {
        type:'text',
        name: 'emal',
        message: 'Your Email: ',
        validate: emal=>validator.validate(emal)? true :'Email invalid!'
    },
    {
        type:'text',
        name: 'ct',
        message: 'Connect with: ',
        validate: ct=>validator.validate(ct)? true :'Email invalid!',
        warning: 'Invalid Email address!'
    },
    {
        type:'text',
        name: 'pw',
        message: 'Password: ',
        hidden: true
    }
];


async function option() {
    const response = await prompt(pr);

        switch (response.option) {
            case 'i'||'I':
                client.emit("sendMsg","Am checking if you are still there!",{id:idi,room:roomI});
                break;
            case 'n'||'N':
                   msg();
              break;
            case 'h'||'H':
                console.log(
                    `
                    \n n or N = new message.
                    \n c or C = connect to another email.
                    \n i or I = check connection.
                    \n o or O = disconnect.
                    \n h or H = help.
                    `
                );
                option();
             break;
             case 'o'||'O':
                start();
             break;
            case 'c'||'C':
                const results = await prompt(contTo);
                    
                    let g;
                    if (results.cts == email) {
                       g = email ;
                    }else g = results.cts;
                    client.emit("Notif",{id:idi,room:g});
                    client.emit("sendMsg",`Hello!\n This is: \t\t$${name}`,{id:idi,room:g});
                  
                 
            break;
        
        }
}
async function regester() {
    const response = await prompt(user);

        if (response.ct =="I@me.com") {
            roomI = response.emal;
        }else roomI = response.ct;
        name = response.usr,Password = response.pw,email=response.emal;
        client.emit("user-add", {
            clientname:response.usr,
            clientemail: response.emal,
            clientContact: "none",
            reason: "none",
            password: Password
        });

}
async function login(){
        const response = await prompt(passw);
        let emailUser = response.email, passwordUser = response.psw;
        client.emit('Login',{
            email:emailUser,
            Password:passwordUser
        });
}

// console.log('\n\n Do you have an account:(Y|N)\n');
var name,Password,email,roomI,idi;

async function start() {


    const response = await prompt(answe);
    if (response.Asw == "N" || response.Asw == "n") {
        regester();
    }else if(response.Asw == "Y" || response.Asw == "y"){
        login();
        
    }

}

start();



client.on('User-added',data=>{
    if (typeof data == 'string') {
        console.log("\n[-]"+data);
        regester();
    }else{
        idi = data.id;
        client.emit("Notif",{id:idi,room:roomI});
        client.emit("sendMsg",`Hello!\n This is: \t\t$${name}`,{id:idi,room:roomI})

    }
})

client.on('login',data=>{
    if (typeof data == 'string') {
        console.log("\n[-]"+data);
        login();

    }else{
        idi = data.id;
        (async ()=>{
           const result = await prompt(contTo);
                    
                    let g;
                    if (result.cts == email) {
                       g = email ;
                    }else g = result.cts;
                    client.emit("Notif",{id:idi,room:g});
                    client.emit("sendMsg",`Hello!\n This is: \t\t$${name}`,{id:idi,room:g});
                })();
   
    }
})

async function msg() {

        const result = await prompt(
            {
                type: 'text',
                name: 'Msg',
                message: 'Msg:'
              }
        );

        client.emit("sendMsg",result.Msg,{id:idi,room:roomI});
        console.log("\n[?]Wait response ....\n");
        // option();

    
}

client.on("connectedUser",data=>{
    console.log("\n\n [+]You are connected!\n [+]Waiting feedback....\t ok!\n" );
    msg();
    
});


client.on("info",(ms,ob)=>{
    console.log("\n"+ms+":\n\t\t"+ob);
})

client.on("msCli",data=>{
    console.log(`\n\n [!]${data}\n [+]Feedback....\t ok!\n` );
    
    
});

client.on('message',data=>{
    if (data.userId != idi) {
        console.log(`\n ${data.user}: ${data.text} \n` );
        
        msg();

        
    }
})



 